<?php

/*
Plugin Name: Prime Mover
Plugin URI: https://codexonics.com/
Description: The simplest all-around WP migration and backup plugin. This is used for single-site / multisite migration and backup purposes.
Version: 1.0.4-beta
Author: Codexonics
Author URI: https://codexonics.com/
Text Domain: prime-mover
Network: True
*/
// Exit if accessed directly
if ( !defined( 'ABSPATH' ) ) {
    exit;
}

if ( function_exists( 'pm_fs' ) ) {
    pm_fs()->set_basename( false, __FILE__ );
} else {
    
    if ( !function_exists( 'pm_fs' ) ) {
        // Create a helper function for easy SDK access.
        function pm_fs()
        {
            global  $pm_fs ;
            
            if ( !isset( $pm_fs ) ) {
                // Activate multisite network integration.
                if ( !defined( 'WP_FS__PRODUCT_3826_MULTISITE' ) ) {
                    define( 'WP_FS__PRODUCT_3826_MULTISITE', true );
                }
                // Include Freemius SDK.
                require_once dirname( __FILE__ ) . '/freemius/start.php';
                $pm_fs = fs_dynamic_init( array(
                    'id'             => '3826',
                    'slug'           => 'prime-mover',
                    'premium_slug'   => 'prime-mover-pro',
                    'type'           => 'plugin',
                    'public_key'     => 'pk_a69fd5401be20bf46608b1c38165b',
                    'is_premium'     => false,
                    'premium_suffix' => 'Pro',
                    'has_addons'     => false,
                    'has_paid_plans' => true,
                    'trial'          => array(
                    'days'               => 14,
                    'is_require_payment' => true,
                ),
                    'menu'           => array(
                    'slug'    => 'migration-panel-settings',
                    'network' => true,
                ),
                    'is_live'        => true,
                ) );
            }
            
            return $pm_fs;
        }
        
        // Init Freemius.
        pm_fs();
        // Signal that SDK was initiated.
        do_action( 'pm_fs_loaded' );
    }
    
    if ( defined( 'PRIME_MOVER_PLUGIN_PATH' ) ) {
        return;
    }
    define( 'PRIME_MOVER_PLUGIN_PATH', plugin_dir_path( __FILE__ ) );
    if ( defined( 'PRIME_MOVER_PLUGIN_CORE_PATH' ) ) {
        return;
    }
    define( 'PRIME_MOVER_PLUGIN_CORE_PATH', dirname( PRIME_MOVER_PLUGIN_PATH ) . DIRECTORY_SEPARATOR );
    if ( defined( 'PRIME_MOVER_PLUGIN_UTILITIES_PATH' ) ) {
        return;
    }
    define( 'PRIME_MOVER_PLUGIN_UTILITIES_PATH', PRIME_MOVER_PLUGIN_PATH . 'utilities' . DIRECTORY_SEPARATOR );
    if ( defined( 'PRIME_MOVER_THEME_CORE_PATH' ) ) {
        return;
    }
    define( 'PRIME_MOVER_THEME_CORE_PATH', get_theme_root() );
    if ( !defined( 'PRIME_MOVER_PLUGIN_URI' ) ) {
        define( 'PRIME_MOVER_PLUGIN_URI', 'https://codexonics.com/' );
    }
    if ( !defined( 'CODEXONICS_CONTACT' ) ) {
        define( 'CODEXONICS_CONTACT', 'https://codexonics.com/contact/' );
    }
    if ( !defined( 'CODEXONICS_DOCUMENTATION' ) ) {
        define( 'CODEXONICS_DOCUMENTATION', 'https://codexonics.com/prime_mover/prime-mover/' );
    }
    if ( !defined( 'PRIME_MOVER_PLUGIN_FILE' ) ) {
        define( 'PRIME_MOVER_PLUGIN_FILE', basename( __FILE__ ) );
    }
    if ( !defined( 'PRIME_MOVER_SECURE_PROTOCOL' ) ) {
        define( 'PRIME_MOVER_SECURE_PROTOCOL', 'https://' );
    }
    if ( !defined( 'PRIME_MOVER_NON_SECURE_PROTOCOL' ) ) {
        define( 'PRIME_MOVER_NON_SECURE_PROTOCOL', 'http://' );
    }
    if ( !defined( 'PRIME_MOVER_UPLOADRETRY_LIMIT' ) ) {
        define( 'PRIME_MOVER_UPLOADRETRY_LIMIT', 25 );
    }
    if ( !defined( 'PRIME_MOVER_TOTAL_WAITING_ERROR_SECONDS' ) ) {
        define( 'PRIME_MOVER_TOTAL_WAITING_ERROR_SECONDS', 120 );
    }
    if ( !defined( 'PRIME_MOVER_JS_ERROR_ANALYSIS' ) ) {
        define( 'PRIME_MOVER_JS_ERROR_ANALYSIS', false );
    }
    if ( !defined( 'PRIME_MOVER_UPLOAD_REFRESH_INTERVAL' ) ) {
        define( 'PRIME_MOVER_UPLOAD_REFRESH_INTERVAL', 5000 );
    }
    if ( !defined( 'PRIME_MOVER_DEFAULT_FREE_BASENAME' ) ) {
        define( 'PRIME_MOVER_DEFAULT_FREE_BASENAME', 'prime-mover/prime-mover.php' );
    }
    if ( !defined( 'PRIME_MOVER_DEFAULT_PRO_BASENAME' ) ) {
        define( 'PRIME_MOVER_DEFAULT_PRO_BASENAME', 'prime-mover-pro/prime-mover.php' );
    }
    define( 'PRIME_MOVER_VERSION', '1.0.4-beta' );
    define( 'PRIME_MOVER_PLUGIN_CODENAME', 'Prime Mover' );
    define( 'PRIME_MOVER_MAINPLUGIN_FILE', __FILE__ );
    include dirname( __FILE__ ) . '/dependency-checks/PrimeMoverPHPVersionDependencies.php';
    include dirname( __FILE__ ) . '/dependency-checks/PrimeMoverWPCoreDepedencies.php';
    include dirname( __FILE__ ) . '/dependency-checks/PrimeMoverRequirementsCheck.php';
    include dirname( __FILE__ ) . '/dependency-checks/PrimeMoverPHPCoreFunctionDependencies.php';
    include dirname( __FILE__ ) . '/dependency-checks/PrimeMoverFileSystemDependencies.php';
    include dirname( __FILE__ ) . '/dependency-checks/PrimeMoverPluginSlugDependencies.php';
    $phpverdependency = new PrimeMoverPHPVersionDependencies( '5.6' );
    $wpcoredependency = new PrimeMoverWPCoreDependencies( '4.9.8' );
    $phpfuncdependency = new PrimeMoverPHPCoreFunctionDependencies();
    $foldernamedependency = new PrimeMoverPluginSlugDependencies( array( PRIME_MOVER_DEFAULT_FREE_BASENAME, PRIME_MOVER_DEFAULT_PRO_BASENAME ) );
    $required_paths = array(
        ABSPATH,
        PRIME_MOVER_PLUGIN_CORE_PATH,
        PRIME_MOVER_PLUGIN_PATH,
        PRIME_MOVER_THEME_CORE_PATH,
        get_stylesheet_directory()
    );
    $wp_upload_dir = wp_upload_dir();
    if ( !empty($wp_upload_dir['basedir']) ) {
        $required_paths[] = $wp_upload_dir['basedir'];
    }
    if ( !empty($wp_upload_dir['path']) ) {
        $required_paths[] = $wp_upload_dir['path'];
    }
    $filesystem_dependency = new PrimeMoverFileSystemDependencies( $required_paths );
    $multisitemigrationcheck = new PrimeMoverRequirementsCheck(
        $phpverdependency,
        $wpcoredependency,
        $phpfuncdependency,
        $filesystem_dependency,
        $foldernamedependency
    );
    if ( !$multisitemigrationcheck->passes() ) {
        return;
    }
    include dirname( __FILE__ ) . '/PrimeMoverLoader.php';
    if ( file_exists( PRIME_MOVER_PLUGIN_PATH . '/vendor/autoload.php' ) ) {
        require_once PRIME_MOVER_PLUGIN_PATH . '/vendor/autoload.php';
    }
    include dirname( __FILE__ ) . '/PrimeMoverFactory.php';
}
